class MONSTER
inherit THING
creation make
feature
	make(initial_square : like square) is
	do
		square := initial_square
		if square /= Void then
			square.put_monster(Current)
		else
			io.put_string("Uh oh: making monster with Void square%N")
			die_with_code(1)
		end
	end

	move_to(destination_square : like square) is
	do
		leave_square
		enter_square(destination_square)
	end

	leave_square is
	require
		square = Void or square.monster = Current
	do
		if square /= Void then
			square.remove_monster
		end
	end

	enter_square(destination_square : like square) is
	require
		square = Void
		destination_square.monster = Void
	do
		destination_square.put_monster(Current)
		square := destination_square
	end

	die is
	do
		leave_square
	end

	start_push(d : INTEGER) is
	local
		sq : SQUARE
	do
		sq := square.adjacent(d)
		if sq.dominant.try_push(d) then
			move_to(sq)
		end
	end

	try_start_push(d : INTEGER) : BOOLEAN is
		-- same as previous, but returns a flag
		-- indicating success
	local
		sq : SQUARE
	do
		sq := square.adjacent(d)
		Result := sq.dominant.try_push(d)
		if Result then
			move_to(sq)
		end
	end

	try_stay_push(d : INTEGER) : BOOLEAN is
		-- same as previous, but don't actually move
	local
		sq : SQUARE
	do
		sq := square.adjacent(d)
		Result := sq.dominant.try_push(d)
	end

	can_start_push(d : INTEGER) : BOOLEAN is
	local
		sq : SQUARE
	do
		sq := square.adjacent(d)
		Result := sq.dominant.can_push(d)
	end

	try_push(d : INTEGER) : BOOLEAN is
	local
		sq : SQUARE
	do
		if can_push_me(d) then
			sq := square.adjacent(d)
			Result := sq.dominant.try_push(d)
			if Result then
				move_to(sq)
			end
		end
	end

	can_push(d : INTEGER) : BOOLEAN is
	local
		sq : SQUARE
	do
		if can_push_me(d) then
			sq := square.adjacent(d)
			Result := sq.dominant.can_push(d)
		end
	end
	
	try_walk(d : INTEGER) : BOOLEAN is
	local
		sq : SQUARE
	do
		sq := square.adjacent(d)
		if sq.dominant.can_walk_on then
			move_to(sq)
			Result := true
		end
	end

	can_walk(d : INTEGER) : BOOLEAN is
	do
		Result := square.adjacent(d).dominant.can_walk_on
	end
end
