class STAR
inherit
	TICKABLE
		redefine
			make
		end
	DIRECTION
	KNOWS_MASTER
creation make, make_for_world, make_shoot
feature
	aim : INTEGER
	owner : INTEGER
		-- 0 = player
		-- 1 = other

	make(initial_square : like square) is
	do
		square := initial_square
		if square /= Void then
			square.put_monster(Current)
		--else if Void then it means we're shooting
		end
		animation_cycle := 0
		put_chr(star_chr @ animation_cycle)
		put_colour(9)
		life := 100
	end

	read_init_rest(header : OBJECT_HEADER) is
	do
		owner := header.p1
		life := header.p2
		aim := direction_from_xy(header.xstep, header.ystep)
		if owner = 0 then
			io.put_string("Uh oh: player appears to own a star%N")
		end
		io.put_string("Star:")
		print(header)
	end

	make_shoot(shooter_square : SQUARE; aim_init : INTEGER; owner_init : INTEGER) is
	do
		make(Void)
		cycle := 1
		cycle_count := 1
		aim := aim_init
		owner := owner_init
		if owner = 0 then
			io.put_string("Uh oh: player appears to own a star%N")
		end
		life := 100

		star_to(shooter_square.adjacent(aim))

		if square /= Void then
			shooter_square.map.tick_list.add_last(Current)
			ticker_on
		end
	end

	star_to(sq : SQUARE) is
	local
		s : STRING
	do
		s := sq.dominant.kind
		if s.is_equal("empty") or else s.is_equal("fake") or else s.is_equal("water") then
			move_to(sq)
		elseif s.is_equal("breakable") then
			sq.dominant.blast
			die
		elseif s.is_equal("player") then
			dungeon_master.player.hurt
			die
		end
	end

	animation_cycle : INTEGER

	cycle_tick is
	local
		c : INTEGER
		dir : INTEGER
	do
		life := life - 1
		if life > 0 then
			animation_cycle := animation_cycle + 1
			if animation_cycle > 3 then
				animation_cycle := 0
			end
			put_chr(star_chr @ animation_cycle)
			c := colour + 1
			if c > 15 then
				c := 9
			end
			put_colour(c)
			if animation_cycle = 0 or else animation_cycle = 2 then
				dir := seek_direction(square.location, dungeon_master.player.square.location)
				star_to(square.adjacent(dir))
			end
		else
			die
		end
	end

	kind : STRING is "star"
	zzt_code : INTEGER is 15

feature {NONE}
	life : INTEGER

	star_chr : ARRAY[INTEGER] is
	once
		!!Result.make(0, 3)
		Result.put(179, 0)
		Result.put(('/').code, 1)
		Result.put(196, 2)
		Result.put(('\').code, 3)
	end
end
